import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Query;
import org.hibernate.cfg.Configuration;

import java.util.Date;
import java.util.List;

public class EmpManager {

    public static void main(String[] args) {

        EmpManager mgr = new EmpManager();

        Configuration config = new Configuration().configure(); 
        SessionFactory sessionFactory = config.buildSessionFactory();
        Session session = sessionFactory.getCurrentSession();
        session.beginTransaction();
        
        //Persist several instances of the Java object Emp to the database table EMP
        mgr.createAndStoreObjects(session, "Tyler", "Bennett", new Date("1977/06/01"), (float) 32000.00, "D101", 1, "");
        mgr.createAndStoreObjects(session, "John", "Rappl", new Date("1987/07/15"), (float) 47000.00, "D050", 1, "");
        mgr.createAndStoreObjects(session, "George", "Woltman", new Date("1982/08/07"), (float) 53500.00, "D101", 1, "");
        mgr.createAndStoreObjects(session, "Adam", "Smith", new Date("1988/01/15"), (float) 18000.00, "D202", 0, "");
        mgr.createAndStoreObjects(session, "David", "McClellan", new Date("1982/07/27"), (float) 41500.00, "D101", 1, "");
        
        //Retrieve the persisted objects from the database and display them on the console.
        mgr.listObjects(session);
        
        //Commit the transaction
        session.getTransaction().commit();
        
        //Close the current session factory and unbind it from the thread.
        sessionFactory.close();
    }

    private void createAndStoreObjects(Session session,
    				       String firstName,
    				       String lastName,
				       Date hireDate,
				       float salary,
				       String dept,
				       int exempt,
				       String interests) {

        Emp theEmp = new Emp();
        theEmp.setFirstName(firstName);
        theEmp.setLastName(lastName);
        theEmp.setHireDate(hireDate);
        theEmp.setSalary(salary);
        theEmp.setDept(dept);
        theEmp.setExempt(exempt);
        theEmp.setInterests(interests);

        session.save(theEmp);

    }
    
    private void listObjects(Session session) {

    	//Use the currect session to retrive records as a Java List of objects.
    	Query hibernateQuery = session.createQuery("from Emp");
        List emps = hibernateQuery.list();
        for (int i = 0; i < emps.size(); i++) {
            Emp theEmp = (Emp) emps.get(i);
            System.out.println("Emp Id: " + theEmp.getEmpId());
            System.out.println("  First Name: " + theEmp.getFirstName());
            System.out.println("  Last Name: " + theEmp.getLastName());
            System.out.println("  Hire Date: " + theEmp.getHireDate());
            System.out.println("  Salary: " + theEmp.getSalary());
            System.out.println("  Dept: " + theEmp.getDept());
            System.out.println("  Exempt: " + theEmp.getExempt());
            System.out.println("  Interests: " + theEmp.getInterests());
        }

        return;
    }

}